'''
Cafe Ban v1.4
Written by RideGuy & XE_ManUp
Concept by Hacker Killer

Bans all STEAMIDs that are suspected to be a cafe account.  All cafe accounts
are 7 digits long and start with 7.  You can prevent legit STEAMIDs that fall
into this criteria from being banned by adding them to the whitelist.txt file.
Example cafe account STEAM_0:x:7xxxxxx
'''

import es
import urllib2
import socket

# Average query time for a real player on an empyt listen server was about 1.5 - 1.75 seconds
timeout = 5
socket.setdefaulttimeout(timeout)

es.ServerVar('cafeban', 1.4).makepublic()
whiteList = []

def load():
    es.ServerVar('cafeban_bantype').set('1')
    es.server.cmd('exec cafeban/cafeban.cfg')
    getWhiteList()

def player_activate(event_var):
    steamid = event_var['es_steamid']
    userid = event_var['userid']
    
    if steamid == 'STEAM_ID_LAN':
        return
    
    if steamid == 'BOT':
        return
    
    if steamid == 'STEAM_ID_PENDING':
        es.server.queuecmd('kickid %s "Steamid still pending. Retry please."' % userid)
        return
    
    if len(steamID) != 17:
        return
    
    if steamID[10:11] != '7':
        return
    
    if steamID in whiteList:
        return
    
    # Retrieve the Steam Community URL
    serverid = steamid[8]
    steamid = steamid.replace('STEAM_0:' + serverid + ':', '')
    communityid = int(steamid) * 2 + int(serverid) + 76561197960265728
    url = 'http://steamcommunity.com/profiles/%d' % communityid
    
    # Open and read the Steam Community URL
    res = urllib2.urlopen(url)
    page = res.read()
    
    # If the profile is private, it is HIGHLY LIKELY this is a Cafe Account
    if 'profile is currently private' not in page:
        return
    
    playerName = event_var['es_username']
    
    # Ban the player
    if es.ServerVar('cafeban_bantype') == '2':
        es.server.queuecmd('banid 0 %s' % steamID)
        es.server.queuecmd('writeid')
        es.server.queuecmd('kickid %s "Kicked for using a Cafe Account"' % userid)
        bannedListFile = open(es.getAddonPath('cafeban') + '/bannedlist.txt', 'a')
        bannedListFile.write('%s - %s\n' % (steamID, playerName))
        bannedListFile.flush()
        bannedListFile.close()
    # Kick the player
    elif es.ServerVar('cafeban_bantype') == '1':
        es.server.queuecmd('kickid %s "Kicked for using a Cafe Account"' % userid)
    # No action, print to console
    else:
        es.dbgmsg(0, 'Player %s (%s): Not kicked or banned. cafeban_bantype not set to 1 or 2.' %(playerName, steamid))

def getWhiteList():
    whiteListFile = open(es.getAddonPath('cafeban') + '/whitelist.txt', 'r')
    for line in whiteListFile:
        line = line.strip()
        if not line.startswith('//') and line != '':
            whiteList.append(line)